FUNCTION create_specpr_listing,FILE_SPECPR=file_specpr,NUM_RECS=num_recs,RECORD_NUMBERS=record_numbers
;
; FOR TEXT RECORDS, THE DATE IS SET TO BLANK
;
DEBUG = 0
start_secs = SYSTIME(/SECONDS)
;
if keyword_set(file_specpr) then do_file_specpr=0  else do_file_specpr=1
;
if (do_file_specpr eq 1) then begin
  file_specpr = envi_pickfile(TITLE='Select the specpr file')
endif
;
openr,lun_specpr,file_specpr,ERROR=err,/GET_LUN
if (err ne 0) then begin
  print,'Error: Could not open selected input file = ',file_specpr
  print,' Error message = ',!ERROR_STATE.MSG
endif else begin
  close,lun_specpr
  free_lun,lun_specpr
endelse
;
recnums = read_specpr_record_list(file_specpr,TITLE=titles,/NO_PRINT,NUM_CHANS=num_chans,DATES=dates,REC_TYPES=rec_types)
if(recnums(0) eq -1) then begin
  RETURN,'-1'
endif
;
num_recs = n_elements(recnums)
;
title_blank    = '                                        '
title_strings = strarr(num_recs)
for irec=0,num_recs-1,1 do begin
  title_temp = title_blank
  strput,title_temp,titles(irec)
  title_strings(irec)=title_temp
endfor
;
; CREATE THE FIRST LISTING
;
date_strings = create_datestrings(dates)
rec_str = string(recnums(0),format="(i6)")
chans_str = string(num_chans(0),format="(i8)")
if(rec_types(0) eq 1) then begin
  date_strings(0) = '          '
endif
temp_str = rec_str+'    '+title_strings(0)+'  '+chans_str+'  '+date_strings(0)
list_str = temp_str
for i=1,num_recs-1,1 do begin
  rec_str   = string(recnums(i),format="(i6)")
  chans_str = string(num_chans(i),format="(i8)")
  if(rec_types(i) eq 1) then begin
    date_strings(i) = '          '
  endif
  temp_str = rec_str+'    '+title_strings(i)+'  '+chans_str+'  '+date_strings(i)
  list_str = [list_str, temp_str]
endfor
;
stop_secs = SYSTIME(/SECONDS)
elapsed_secs = stop_secs-start_secs
if(DEBUG ge 1) then print,'create_specpr_listing: processing time = ',elapsed_secs,' seconds'
;
record_numbers = recnums
RETURN,list_str
;
end