;-----------------------------------------------------------------
;
; This file contains IDL programs for the "View_SPECPR" software.
; Raymond F. Kokaly
; US Geological Survey
;
;-----------------------------------------------------------------

;-----------------------------------------------------------------
PRO SpecprList_exit,event
widget_control,event.top,/DESTROY
end


;------------------------------------------------------------------------
PRO SpecprList_cleanup,tlb
widget_control,tlb,GET_UVALUE=pstate
iplotIDs = (*pstate).iplotIDs
for i=0,n_elements(iplotIDs)-1,1 do begin
  if(iplotIDs(i) ne 'empty') then ITDELETE, iplotIDs(i)
endfor
;ptr_free,pstate
end


;-----------------------------------------------------------------
PRO SpecprList_event,event
;
widget_control, event.top, GET_UVALUE = pstate
widget_control, event.id,  GET_UVALUE = uval
num_elements=n_elements(uval)
;
(*pstate).selected_recnums(*) = 0L
;
if (num_elements eq 1) then begin
  if(uval eq 'returnButton') then begin
    widget_control, event.top, get_uvalue = valsListID
    selected = widget_info((*pstate).valsListID, /list_select)
;   print, 'Selected Items : ', selected
    test_selected = 1
    if(n_elements(selected) eq 1) then begin
      if(selected eq -1) then test_selected=0
    endif
    if(test_selected eq 1) then (*pstate).selected_recnums(selected) = 1L
  endif
  SpecprList_exit,event
endif
;
end


;-----------------------------------------------------------------
pro SpecprList_selectfile, Event
;
; THIS SUBROUTINE IS CALLED IF THE USER PRESSES THE "Select SPECPR File' BUTTON
;
widget_control,event.top,GET_UVALUE=pstate
;
sfile=dialog_pickfile(path=(*pstate).currDir,/READ)
if(sfile ne '') then begin
  (*pstate).filename = sfile
  Widget_Control,(*pstate).selectTextID,set_value=sfile
  basename,sfile,basefilename,pathname
  (*pstate).currDir = pathname
  (*pstate).tempfile = pathname+(*pstate).tempname
  (*pstate).currFile = basefilename
  widget_control,(*pstate).gorecID,TRACKING_EVENTS=0
endif
;
end


;--------------------------------------------------------------------------
PRO SpecprList_gorec, event
;
; READ THE USER INPUT VALUE AND PROCESS AND RESET TO SCREEN
;
widget_control,event.top,GET_UVALUE=pstate
DEBUG                 = (*pstate).DEBUG
DISPLAY_MODE          = (*pstate).DISPLAY_MODE
specprfile            = (*pstate).filename
str_default_assocwave = (*pstate).str_default_assocwave
;
widget_control,(*pstate).gorecID,GET_VALUE=gorec_str
test_length=strlen(gorec_str)
if(gorec_str ne 'NoneSelected') then begin
  if (test_length ne 0) then begin
    reads,gorec_str,gorec
    gorec = long(gorec)
    gorec_str = strcompress(string(gorec),/REMOVE_ALL)
;
;   DO ERROR CHECKING (CHECK RECORD > 0)
    if (gorec lt 1) then begin
      err_mesg=['The record must be set to a positive integer value.']
      err_mesg=[err_mesg,'Please enter a correct value.']
      c=dialog_message(err_mesg)
      widget_control,(*pstate).gorecID,SET_VALUE='1'
      widget_control,(*pstate).gorecID,GET_VALUE=gorec_str
      widget_control,(*pstate).valsListID,SET_LIST_TOP=0
      widget_control,(*pstate).valsListID,SET_LIST_SELECT=0
      reads,gorec_str,gorec
      gorec = long(gorec)
      gorec_str = strcompress(string(gorec),/REMOVE_ALL)
    endif
    widget_control,(*pstate).gorecLabelID,GET_UVALUE=recnums
    diff = recnums - gorec
    mindiff = min(abs(diff),index_min)
    gorec = recnums(index_min)
    gorec_str = strcompress(string(gorec),/REMOVE_ALL)
    widget_control,(*pstate).gorecID,SET_VALUE=gorec_str
    index_top = index_min - 5
    if (index_top lt 0) then index_top = 0
    widget_control,(*pstate).valsListID,SET_LIST_TOP=index_top
    widget_control,(*pstate).valsListID,SET_LIST_SELECT=index_min
    if(specprfile eq (*pstate).unselectedfile) then begin
;     NO ACTION IF A FILE HAS NOT BEEN READ YET
    endif else begin
      ival_read = read_specpr(specprfile,gorec,data,title,header,/NO_PRINT,/NO_PLOT)
      if(ival_read eq 0) then begin
        waverec   = long(header.irwav)
        str_waverec = strcompress(string(waverec))
      endif else begin
        waverec     = 0L
        str_waverec = 'N/A'
      endelse
      if(DEBUG eq 1) then print,waverec,'    ',str_waverec,'    ',(*pstate).assocwaveTextID
      str_assocwave = str_default_assocwave+' '+str_waverec
      if(DISPLAY_MODE eq 0) then begin
        Widget_Control,(*pstate).assocwaveTextID,set_value=str_assocwave
        Widget_Control,(*pstate).assocwaveTextID,set_uvalue=waverec
      endif
    endelse
  endif else begin
    err_mesg=['The record must be set to a positive integer value.']
    err_mesg=[err_mesg,'Please enter a correct value.']
    c=dialog_message(err_mesg)
    widget_control,(*pstate).gorecID,SET_VALUE='1'
    widget_control,(*pstate).gorecID,GET_VALUE=gorec_str
    widget_control,(*pstate).valsListID,SET_LIST_TOP=0
    widget_control,(*pstate).valsListID,SET_LIST_SELECT=0
  endelse
endif
;
end


;--------------------------------------------------------------------------
PRO SpecprList_wave, event
;
; READ THE USER INPUT VALUE AND PROCESS AND RESET TO SCREEN
;
Widget_Control,event.top,GET_UVALUE=pstate
Widget_Control,(*pstate).waveID,GET_VALUE=wave_str
;
DEBUG             = (*pstate).DEBUG
DISPLAY_MODE      = (*pstate).DISPLAY_MODE
;
test_length=strlen(wave_str)
;
if (test_length ne 0) then begin
  reads,wave_str,wave
  wave = long(wave)
  wave_str = strcompress(string(wave),/REMOVE_ALL)
endif else begin
  err_mesg=['The record must be set to a positive integer value.']
  err_mesg=[err_mesg,'Please enter a correct value.']
  c=dialog_message(err_mesg)
  widget_control,(*pstate).waveID,SET_VALUE='1'
  widget_control,(*pstate).waveID,GET_VALUE=wave_str
  widget_control,(*pstate).valsListID,SET_LIST_TOP=0
  widget_control,(*pstate).valsListID,SET_LIST_SELECT=0
  reads,wave_str,wave
  wave = long(wave)
  wave_str = strcompress(string(wave),/REMOVE_ALL)
endelse
;
;DO ERROR CHECKING (WAVE RECORD MUST MATCH A DISPLAYED RECORD NUMBER)
;
case DISPLAY_MODE of
  0: begin
    if(wave gt 0) then begin
      recnums = (*pstate).recnums
      index_wave = where(recnums eq wave,count_wave)
      if(index_wave eq -1) then begin
        err_mesg=['The record must be set to a record number in the displayed SPECPR file.']
        err_mesg=[err_mesg,'Please enter a correct value.']
        c=dialog_message(err_mesg)
        widget_control,(*pstate).waveID,SET_VALUE='1'
        widget_control,(*pstate).waveID,GET_VALUE=wave_str
        reads,wave_str,wave
        wave = long(wave)
        wave_str = strcompress(string(wave),/REMOVE_ALL)
      endif
    endif
  end
  1: begin
  end
  2: begin
  end
endcase
;
widget_control,(*pstate).waveID,SET_VALUE=wave_str
(*pstate).waverec=wave
;
if(DISPLAY_MODE eq 1) then begin
  widget_control,(*pstate).waveLabelID,GET_UVALUE=recnums
  diff = recnums - wave
  mindiff = min(abs(diff),index_min)
  wave = recnums(index_min)
  wave_str = strcompress(string(wave),/REMOVE_ALL)
  widget_control,(*pstate).waveID,SET_VALUE=wave_str
  index_top = index_min - 5
  if (index_top lt 0) then index_top = 0
  widget_control,(*pstate).valsListID,SET_LIST_TOP=index_top
  widget_control,(*pstate).valsListID,SET_LIST_SELECT=index_min
endif
;
end

;--------------------------------------------------------------------------
PRO SpecprList_setwave, event
;
; READ THE USER INPUT VALUE AND PROCESS AND RESET TO SCREEN
;
Widget_Control,event.top,GET_UVALUE=pstate
Widget_Control,(*pstate).assocwaveTextID,GET_UVALUE=wave
;
DEBUG             = (*pstate).DEBUG
;
if(wave gt 0) then begin
  if (DEBUG ge 1) then print,wave
  wave_str = strcompress(string(wave),/REMOVE_ALL)
  widget_control,(*pstate).waveID,SET_VALUE=wave_str
  (*pstate).waverec=wave
endif
;
end


;------------------------------------------------------------------------
PRO SpecprList_list,Event
;
; THIS CODE EXECUTES IF SOMETHING IS SELECTED FROM THE LIST
;
widget_control,Event.top,GET_UVALUE=pstate
DEBUG                 = (*pstate).DEBUG
specprfile            = (*pstate).filename
do_singlerec          = (*pstate).do_singlerec
do_records_select     = (*pstate).do_records_select
DISPLAY_MODE          = (*pstate).DISPLAY_MODE
str_default_assocwave = (*pstate).str_default_assocwave
index=Event.index
;
case DISPLAY_MODE of
  0: begin
    if(DEBUG ge 1) then print,'SpecprList_list: Here I am 0'
    Widget_Control,(*pstate).gorecLabelID,GET_UVALUE=recnums
    recnum     = recnums(index)
    str_recnum = strcompress(string(recnums(index)))
    Widget_Control,(*pstate).gorecID,set_value=str_recnum
    Widget_Control,(*pstate).valsListID,SET_LIST_SELECT=index
    if(recnum ge 1) then begin
      ival_read = read_specpr(specprfile,recnum,data,title,header,/NO_PRINT,/NO_PLOT)
    endif
    if(ival_read eq 0) then begin
      waverec   = long(header.irwav)
      str_waverec = strcompress(string(waverec))
    endif else begin
      waverec     = 0L
      str_waverec = 'N/A'
    endelse
    if(DEBUG eq 1) then print,waverec,'    ',str_waverec,'    ',(*pstate).assocwaveTextID
    str_assocwave = str_default_assocwave+' '+str_waverec
    Widget_Control,(*pstate).assocwaveTextID,set_value=str_assocwave
    Widget_Control,(*pstate).assocwaveTextID,set_uvalue=waverec
  end
  1: begin
    if(DEBUG ge 1) then print,'SpecprList_list: Here I am 1'
    Widget_Control,(*pstate).waveLabelID,GET_UVALUE=recnums
    Widget_Control,(*pstate).waveID,set_value=strcompress(string(recnums(index)))
    Widget_Control,(*pstate).valsListID,SET_LIST_SELECT=index
    (*pstate).waverec = recnums(index)
  end
  2: begin
    if(DEBUG ge 1) then print,'SpecprList_list: Here I am 2'
    Widget_Control,(*pstate).gorecLabelID,GET_UVALUE=recnums
    Widget_Control,(*pstate).gorecID,set_value=strcompress(string(recnums(index)))
    Widget_Control,(*pstate).valsListID,SET_LIST_SELECT=index
    index_selected                   = widget_info((*pstate).valsListID, /list_select)
    selected_recnums                 = (*pstate).selected_recnums
    selected_recnums(*)              = 0L
    selected_recnums(index_selected) = 1L
    widget_control,(*pstate).valsListID,SET_LIST_SELECT=index_selected
    (*pstate).selected_recnums = selected_recnums
  end
endcase
;
end



;-----------------------------------------------------------------
pro SpecprList_save, Event
widget_control,event.top,GET_UVALUE=pstate
infile = (*pstate).filename
Widget_Control,(*pstate).valsListID,get_uvalue=vals
file_save=dialog_pickfile(/WRITE)
if(file_save ne '') then begin
  openw,lun_vals,file_save,/GET_LUN
  printf,lun_vals,'Saved list of specpr file:',infile
  printf,lun_vals,format='(a)',vals
  close,lun_vals
  free_lun,lun_vals
endif
end

;-----------------------------------------------------------------
pro SpecprList_help, Event
file_help=dialog_pickfile(FILE='C:\view_specpr\view_SPECPR_help.htm',TITLE='Select the View_SPECPR_help file')
if(file_help eq '') then begin
  err_mesg=['The View_SPECPR_help file was not selected.']
  c=dialog_message(err_mesg)
  RETURN
endif
ONLINE_HELP, BOOK=file_help, /FULL_PATH
end

;-----------------------------------------------------------------
PRO SpecprList_text, Event
;
widget_control,event.top,GET_UVALUE=pstate
;
DEBUG          = (*pstate).DEBUG
specprfile     = (*pstate).filename
unselectedfile = (*pstate).unselectedfile
widget_control,(*pstate).gorecID,GET_VALUE=datarec_str
;
if(datarec_str eq 'NoneSelected') then begin
  x=DIALOG_MESSAGE('Error: Record has not been selected.')
  return
endif
;
reads,datarec_str,datarec
datarec = long(datarec)
;
if (specprfile eq unselectedfile) then begin
  x=DIALOG_MESSAGE('Error: SPECPR File has not been read.')
  return
endif
;
test_read = read_specpr(specprfile,datarec,data,title,record_header,/NO_PLOT,/NO_PRINT)
;
if(DEBUG ge 1) then begin
  print,data
  print,byte(data)
endif
;
if(test_read eq -1) then begin
  errtext='Error: selected record could not be read.'
  x=DIALOG_MESSAGE(errtext)
  return
endif
;
record_str = strcompress('Record Number: '+string(datarec))
if(test_read eq 0) then begin
  do_html = 0
  prefix_title     = 'Title: '
  prefix_usernm    = 'Username: '
  prefix_numchans  = 'Number of Channels: '
  prefix_datecoll  = 'Date When Collected: '
  prefix_dateproc  = 'Date Last Processed: '
  prefix_waverec   = 'Wavelength Record: '
  prefix_fwhmrec   = 'FWHM Record: '
  prefix_ahist     = 'Auto History: '
  prefix_mhist     = 'Manual History: '
  text_title    = record_header.ititl
  text_usernm   = record_header.usernm
  text_numchans = strcompress(string(record_header.itchan),/remove_all)
  text_datecoll = create_datestrings(record_header.jdateb)
  text_dateproc = create_datestrings(record_header.jdatea)
  text_waverec  = strcompress(string(record_header.irwav),/remove_all)
  text_fwhmrec  = strcompress(string(record_header.irespt),/remove_all)
  text_ahist    = record_header.ihist
  text_mhist    = record_header.mhist
  text_str     = strarr(14)
  text_str(0)  = record_str
  text_str(1)  = prefix_title  + text_title
  text_str(2)  = prefix_usernm + text_usernm
  text_str(3)  = prefix_numchans + text_numchans
  text_str(4)  = prefix_datecoll + text_datecoll
  text_str(5)  = prefix_dateproc + text_dateproc
  text_str(6)  = prefix_waverec + text_waverec
  text_str(7)  = prefix_fwhmrec + text_fwhmrec
  text_str(8)  = prefix_ahist  + text_ahist
  text_str(9)  = prefix_mhist
  text_str(10)  = text_mhist(0)
  text_str(11)  = text_mhist(1)
  text_str(12)  = text_mhist(2)
  text_str(13 ) = text_mhist(3)
  title_str   = 'Header information for '+record_str
endif else begin
  prefix    = 'Text: '
  text      = data
  text_str  = record_str+prefix+text
  text_str  = split_string(data)
;  num_strings = n_elements(test_str)
;  text_str2  = strarr(num_strings+2)
;  text_str2(0) = record_str
;  text_str2(1) = prefix
;  for istr=0,num_strings-1,1 do begin
;    text_str2(istr+2) = test_str(istr)
;  endfor
  title_str = 'Text for '+record_str
  Result = STRPOS( text, 'DESCRIPT')
  if(Result ne -1) then do_html=1 else do_html=0
endelse
;
if(do_html eq 0) then begin
;  test_display = dialog_message(text_str,TITLE=title_str,/INFORMATION)
  widget_specpr_text,text_str,TITLE_STR=title_str,GROUP_LEADER=event.top
endif else begin
  file_temp = (*pstate).tempfile
  openw,lun_temp,file_temp,/GET_LUN
  printf,lun_temp,text
  close,lun_temp
  flush,lun_temp
  free_lun,lun_temp
;  SPAWN, 'iexplore.exe '+file_temp, /NOSHELL, /NOWAIT
  ONLINE_HELP, BOOK=file_temp, /FULL_PATH
endelse
;
end


;-----------------------------------------------------------------
pro SpecprList_plot, Event
;
TICKLEN_X = 0.025
TICKLEN_Y = 0.025*8.5/11.
;
widget_control,event.top,GET_UVALUE=pstate
;
DEBUG                = (*pstate).DEBUG
plotname_coords_mult = (*pstate).plotname_coords_mult
BAD_VALUE            = (*pstate).BAD_VALUE
MIN_VALUE            = (*pstate).MIN_VALUE
specprfile           = (*pstate).filename
REDS                 = (*pstate).REDS
GRNS                 = (*pstate).GRNS
BLUS                 = (*pstate).BLUS
unselectedfile       = (*pstate).unselectedfile
num_plot_windows     = (*pstate).num_plot_windows
;
if (specprfile eq unselectedfile) then begin
  x=DIALOG_MESSAGE('Error: SPECPR File has not been read.')
  return
endif
;
widget_control,(*pstate).waveID,GET_VALUE=waverec_str
reads,waverec_str,waverec
waverec = long(waverec)
;
widget_control,(*pstate).gorecID,GET_VALUE=datarec_str
if(datarec_str eq 'NoneSelected') then begin
  x=DIALOG_MESSAGE('Error: Wavelength record has not been set.')
  return
endif else begin
  reads,datarec_str,datarec
  datarec = long(datarec)
;
  if (waverec eq -1L) then begin
    x=DIALOG_MESSAGE('Error: Wavelength record has not been set.')
    return
  endif
;
  if (waverec ge 1L) then begin
    test_read = read_specpr(specprfile,waverec,wave,title_wave,record_header_wave,/NO_PLOT,/NO_PRINT)
    if(test_read ne 0) then begin
      errtext='Error: wavelength record must be a data record, not a text record.'
      x=DIALOG_MESSAGE(errtext)
      return
    endif
    test_read = read_specpr(specprfile,datarec,data,title,record_header,NUM_RECS=num_recs_data,/NO_PLOT,/NO_PRINT)
    if(test_read ne 0) then begin
      errtext='Error: selected record must be a data record, not a text record.'
      x=DIALOG_MESSAGE(errtext)
      return
    endif
    str_wave = '(wavelength record = '+waverec_str+')'
;   READ THE ERRORS IF PRESENT
    if (record_header.icflag_bit2_error eq 1) then begin
      do_errors = 1
      errorrec  = datarec+num_recs_data
      test_read = read_specpr(specprfile,errorrec,error,title_error,record_header_error,/NO_PLOT,/NO_PRINT)
      if(test_read ne 0) then begin
        error=replicate(0.0,n_elements(data))
      endif
    endif else begin
      do_errors=0
      error=replicate(0.0,n_elements(data))
    endelse
;
    check_chans = n_elements(wave)-n_elements(data)
    if(check_chans ne 0) then begin
      x=DIALOG_MESSAGE('Error: Data record and wavelength record do not have the same number of channels.')
    endif else begin
;     CHECK FOR DELETED POINT VALUES IN DATA RECORD AND WAVELENGTH RECORD
      index_valid_data = where(data ne BAD_VALUE and wave ne BAD_VALUE,count_valid)
      if(count_valid ge 1) then begin
        data_valid = data(index_valid_data)
        wave_valid = wave(index_valid_data)
        error_valid = error(index_valid_data)
      endif
      xmult  = 0.05
      xmin   = min(wave_valid)
      xmax   = max(wave_valid)
      xspan  = xmax-xmin
      xlo    = xmin-xspan*xmult
      xhi    = xmax+xspan*xmult
      if(xlo lt 0. and xmin gt 0.) then xlo = 0.
      xrange = [xlo,xhi]
      wave_ticklen = (xhi-xlo)*0.05
      if(DEBUG eq 1) then print,'XTICK INFO:',xmin,xmax,xspan,xlo,xhi,xrange,wave_ticklen
      ymult  = 0.05
      ymin   = min(data_valid)
      ymax   = max(data_valid)
      yspan  = ymax-ymin
      if(yspan eq 0.) then yspan = ymin/10.
      if(yspan eq 0. and ymin eq 0.) then yspan = 0.01
      ylo    = ymin-yspan*ymult
      yhi    = ymax+yspan*ymult
      yrange = [ylo,yhi]
      if(ylo lt 0. and ymin gt 0.) then ylo = 0.
      data_ticklen = (yhi-ylo)*0.05
      if(DEBUG eq 1) then print,'YTICK INFO:',ymin,ymax,yspan,ylo,yhi,yrange,data_ticklen
;
      basename,specprfile,specprname,specprdir
      plotdata = data_valid
      index_nan = where(data_valid eq BAD_VALUE,count_nan)
      if(count_nan gt 0) then plotdata(index_nan) = !VALUES.F_NAN
      title_str = 'Record '+strtrim(datarec_str)+' of '+specprname
;
      if(do_errors eq 0) then begin
        iplot,wave_valid,plotdata,XMINOR=4,YMINOR=4,XRANGE=xrange,YRANGE=yrange,$
         TITLE=strcompress(title_str),$
         XTITLE='Wavelength (!9m!N!Xm)',YTITLE='Data',THICK=2.4,$
         COLOR=[REDS(0),GRNS(0),BLUS(0)],$
         IDENTIFIER = specprlistgui_plot,/NO_SAVEPROMPT,$
         DIMENSIONS = [1100,850]*0.75,$
         XTICKLEN=TICKLEN_X,YTICKLEN=TICKLEN_Y
      endif else begin
        iplot,wave_valid,plotdata,XMINOR=4,YMINOR=4,XRANGE=xrange,YRANGE=yrange,$
         TITLE=strcompress(title_str),$
         XTITLE='Wavelength (!9m!N!Xm)',YTITLE='Data',THICK=2.4,$
         COLOR=[REDS(0),GRNS(0),BLUS(0)],$
         IDENTIFIER = specprlistgui_plot,/NO_SAVEPROMPT,$
         DIMENSIONS = [1100,850]*0.75,$
         XTICKLEN=TICKLEN_X,YTICKLEN=TICKLEN_Y,$
         ERRORBAR_COLOR = [REDS(0),GRNS(0),BLUS(0)], $
         ERRORBAR_CAPSIZE = 0.025, Y_ERRORBARS = 0, $
         YERROR = error_valid
      endelse
;
;     Get a reference to the current iTool
;
      idTool = ITGETCURRENT(TOOL=oTool)
      length = strlen(idTool)
      test=strmid(idTool,length-1,1)
      case test of
        'L':begin
          plotwindow_number = 0
        end
        else:begin
          reads,test,plotwindow_number,format='(i)'
          plotwindow_number = fix(plotwindow_number)
        end
      endcase
      if(DEBUG ge 1) then begin
        print,'IDTOOL = ',idTool
        print,'test = ',test
        print,'plot window number = ',plotwindow_number
        idDataSpace = oTool->findIdentifiers('*DATA SPACE*')
        print,idDataSpace
      endif
;
;  ADD TEXT ANNOTATION TO THE IPLOT WINDOW
;
;     Get an object reference to the current iTool's annotation layer
      idAnnotationLayer = oTool->findIdentifiers('*ANNOTATION LAYER')
      oAnnotationLayer  = oTool->getByIdentifier(idAnnotationLayer)
;     Create an annotation
      oTextAnnotation   = OBJ_NEW('IDLitVisText', _STRING='!I'+title_str+': '+title+'      '+str_wave)
;     Add the annotation to the annotation layer
      oAnnotationLayer->add, oTextAnnotation
;
;     GET THE TEXT DIMENSIONS IN ORDER TO POSITION THE TEXT
;
      idTextAnnotation = oTextAnnotation->GetFullIdentifier()
      textDims         = oTextAnnotation->_GetTextDimensions()
      tmTextAnnotation = oTextAnnotation->GetCTM()
      if(DEBUG eq 1) then begin
        print,'Text Annotation Properties:'
        itpropertyreport, oTool, idTextAnnotation
        print,'Text CTM:'
        print,tmTextAnnotation
        print,'Text Dimensions:'
        print,textDims
      endif
;
;     GET THE IDLitVisPlot OBJECT
;
      idPlot = oTool->findIdentifiers('*PLOT*',/VISUALIZATIONS)
      oPlot  = oTool->GetByIdentifier(idPlot)
      tmPlot = oPlot->GetCTM()
      if(DEBUG eq 1) then begin
        print,'Plot CTM:'
        print,tmPlot
      endif
;
;     GET THE IDL VIEWPLANE RECT
;
      idVisLayer = oTool->FindIdentifiers('*VIEW_1/VISUALIZATION LAYER')
      oVisLayer  = oTool->GetByIdentifier(idVisLayer)
      oVisLayer->GetProperty,VIEWPLANE_RECT=vrVisLayer
      oVisLayer->GetProperty,MARGIN_2D_X=xMarginVisLayer
      oVisLayer->GetProperty,MARGIN_2D_Y=yMarginVisLayer
      if(DEBUG eq 1) then begin
        print,'Viewplane Rectangle:'
        print,vrVisLayer
        print,'xMarginVisLayer,yMarginVisLayer:'
        print,xMarginVisLayer,yMarginVisLayer
      endif
;
;     SET THE TEXT POSITION
;
      windowTopCoord  = vrVisLayer[1] + vrVisLayer[3]
      plotLeftCoord   = vrVisLayer[0] + xMarginVisLayer*vrVisLayer[2]
      plotBottomCoord = vrVisLayer[1] + yMarginVisLayer*vrVisLayer[3]*plotname_coords_mult
      XCoord = plotLeftCoord
      YCoord = plotBottomCoord
      oTextAnnotation->translate, XCoord, YCoord, 0
      oTool->CommitActions
;
;
;     UPDATE STATE VARIABLES
;
      (*pstate).iplotIDs(plotwindow_number)    = specprlistgui_plot
      (*pstate).recentiplotid                  = specprlistgui_plot
      (*pstate).datarec                        = datarec
      (*pstate).waverec                        = long(waverec)
      (*pstate).xrange                         = xrange
      (*pstate).yrange                         = yrange
      (*pstate).xrange_mins(plotwindow_number) = xrange(0)
      (*pstate).xrange_maxs(plotwindow_number) = xrange(1)
      (*pstate).yrange_mins(plotwindow_number) = yrange(0)
      (*pstate).yrange_maxs(plotwindow_number) = yrange(1)
      (*pstate).plotname_coords                = [XCoord,YCoord]
      (*pstate).plotname_coords_yoffset        = vrVisLayer[3]/70.
      (*pstate).num_plots(plotwindow_number)   = 1
      (*pstate).num_plot_windows               = num_plot_windows+1
    endelse
  endif
endelse
;
end

;-----------------------------------------------------------------
pro SpecprList_oplot, Event
;
widget_control,event.top,GET_UVALUE=pstate
;
DEBUG                   = (*pstate).DEBUG
BAD_VALUE               = (*pstate).BAD_VALUE
MIN_VALUE               = (*pstate).MIN_VALUE
specprfile              = (*pstate).filename
olddatarec              = (*pstate).datarec
oldwaverec              = (*pstate).waverec
oldxrange               = (*pstate).xrange
oldyrange               = (*pstate).yrange
plotname_coords         = (*pstate).plotname_coords
plotname_coords_mult    = (*pstate).plotname_coords_mult
plotname_coords_yoffset = (*pstate).plotname_coords_yoffset
REDS                    = (*pstate).REDS
GRNS                    = (*pstate).GRNS
BLUS                    = (*pstate).BLUS
NUM_COLORS              = (*pstate).NUM_COLORS
MULTIPLIERS             = (*pstate).MULTIPLIERS
unselectedfile          = (*pstate).unselectedfile
iplotIDs                = (*pstate).iplotIDs
num_plots               = (*pstate).num_plots
;
; CHECK THE STATE OF THE MAIN WIDGET BEFORE OVERPLOTTING
;
if (specprfile eq unselectedfile) then begin
  x=DIALOG_MESSAGE('Error: SPECPR File has not been read.')
  return
endif
;
if (total(num_plots) eq 0) then begin
  x=DIALOG_MESSAGE('Error: A record needs to be plotted before using the overplot function.')
  return
endif
;
widget_control,(*pstate).waveID,GET_VALUE=waverec_str
reads,waverec_str,waverec
waverec = long(waverec)
if (waverec eq -1L) then begin
  x=DIALOG_MESSAGE('Error: Wavelength record has not been set.')
  return
endif
;
widget_control,(*pstate).gorecID,GET_VALUE=datarec_str
reads,datarec_str,datarec
datarec = long(datarec)
;
test_read = read_specpr(specprfile,waverec,wave,title,record_header,/NO_PLOT,/NO_PRINT)
if(test_read ne 0) then begin
  errtext='Error: selected record must be a data record, not a text record.'
  x=DIALOG_MESSAGE(errtext)
  return
endif
;
test_read = read_specpr(specprfile,datarec,data,title,record_header,/NO_PLOT,/NO_PRINT)
if(test_read ne 0) then begin
  errtext='Error: selected record must be a data record, not a text record.'
  x=DIALOG_MESSAGE(errtext)
  return
endif
;
check_chans = n_elements(wave)-n_elements(data)
if(check_chans ne 0) then begin
  x=DIALOG_MESSAGE('Error: Data record and wavelength record do not have the same number of channels.')
  return
endif
str_wave = '(wavelength record = '+waverec_str+')'
;
; GET THE ID OF THE CURRENT PLOT WINDOW (THE LAST ONE THE USER INTERACTED WITH)
;
idTool = ITGETCURRENT(TOOL = oTool)
length=strlen(idTool)
test=strmid(idTool,length-1,1)
if(length gt 0) then begin
  case test of
    'L':begin
      plotwindow_number = 0
    end
    else:begin
      reads,test,plotwindow_number,format='(i)'
      plotwindow_number = fix(plotwindow_number)
    end
  endcase
endif else begin
  plotwindow_number = 0
endelse
oldxrange               = [(*pstate).xrange_mins(plotwindow_number),(*pstate).xrange_maxs(plotwindow_number)]
oldyrange               = [(*pstate).yrange_mins(plotwindow_number),(*pstate).yrange_maxs(plotwindow_number)]
if(DEBUG ge 1) then begin
  print,'IDTOOL = ',idTool
  print,'test = ',test
  print,'plot window number = ',plotwindow_number
  print,'old xrange = ',oldxrange
  print,'old yrange = ',oldyrange
endif
index  = where (idTool eq iplotIDs,count)
if(count lt 1) then begin
  x=DIALOG_MESSAGE('Error: A record needs to be plotted before using the overplot function.')
  return
endif
;
; CHECK FOR DELETED POINT VALUES
;
index_valid_data = where(data ne BAD_VALUE and wave ne BAD_VALUE,count_valid)
if(count_valid ge 1) then begin
  data_valid = data(index_valid_data)
  wave_valid = wave(index_valid_data)
endif
;
idDataSpace = oTool->findIdentifiers('*DATA SPACE')
if(DEBUG ge 1) then begin
  print,idDataSpace
  objDataSpace = oTool->GetByIdentifier(idDataSpace)
  itpropertyreport,oTool,idDataSpace
  propsDataSpace = objDataSpace->QueryProperty()
  print, propsDataSpace
endif
;
; SET THE X & Y AXIS RANGES
;
xmult  = 0.05
xmin   = min(wave_valid)
xmax   = max(wave_valid)
xspan  = xmax-xmin
xlo    = xmin-xspan*xmult
xhi    = xmax+xspan*xmult
if(xlo lt 0. and xmin gt 0.) then xlo = 0.
xrange = [min([xlo,oldxrange]),max([xhi,oldxrange])]
;
ymult  = 0.05
ymin   = min(data_valid)
ymax   = max(data_valid)
yspan  = ymax-ymin
if(yspan eq 0.) then yspan = ymin/10.
ylo    = ymin-yspan*ymult
yhi    = ymax+yspan*ymult
if(ylo lt 0. and ymin gt 0.) then ylo = 0.
yrange = [min([ylo,oldyrange]),max([yhi,oldyrange])]
;
if(DEBUG eq 1) then begin
  print,'DEBUG: x-axis parameters'
  print,xmin,xmax,xspan
  print,xlo,xhi
  print,xrange
  print,'DEBUG: y-axis parameters'
  print,ymin,ymax,yspan
  print,ylo,yhi
  print,yrange
endif
;
; CHECK THE STATE OF THE PLOT TOOL TO DETERMINE THE NUMBER OF SPECTRA
;
idPlotParam = oTool->findIdentifiers('*DATA SPACE*PLOT*')
num_plots_this_iplot=n_elements(idPlotParam)
if(DEBUG ge 1) then begin
  print,idPlotParam
  itpropertyreport,oTool,idPlotParam
  print,'TESTING num_plots_this_plot = ',num_plots_this_iplot
  objPlotParam = oTool->GetByIdentifier(idPlotParam)
  propsPlotParam = objPlotParam->QueryProperty()
  PRINT, propsPlotParam
endif
;
;num_plots_this_iplot = num_plots(index(0))+1
;if(DEBUG ge 1) then print,'num_plots_this_iplot=',num_plots_this_iplot
;
I=floor(num_plots_this_iplot/NUM_COLORS)
if(DEBUG ge 1) then print,'I=',I
index_plots = fix(num_plots_this_iplot - NUM_COLORS*I)
if(DEBUG ge 1) then print,'index_plots=',index_plots
;
plotdata = data_valid
index_nan = where(data_valid eq BAD_VALUE,count_nan)
if(count_nan gt 0) then plotdata(index_nan) = !VALUES.F_NAN
;
basename,specprfile,specprname,specprdir
;
if (I gt n_elements(MULTIPLIERS)-1) then I=n_elements(MULTIPLIERS)-1
COLOR_CURRENT = [REDS(index_plots)*MULTIPLIERS(I),GRNS(index_plots)*MULTIPLIERS(I),BLUS(index_plots)*MULTIPLIERS(I)]
;
iplot,wave_valid,plotdata,OVERPLOT=idTool,$
 COLOR=COLOR_CURRENT,$
 XRANGE=xrange,YRANGE=yrange,TITLE='IPLOT: '+specprname
;
; ADD THE PLOT TITLE INFO TO THE TEXT ANNOTATION
;
if(idTool eq '') then begin
  return
endif
idAnnotationLayer = oTool->findIdentifiers('*ANNOTATION LAYER')
oAnnotationLayer  = oTool->getByIdentifier(idAnnotationLayer)
;
rec_specpr_str = 'Record '+strtrim(datarec_str)+' of '+specprname
;
oTextAnnotation   = OBJ_NEW('IDLitVisText', _STRING='!I'+rec_specpr_str+': '+title+'      '+str_wave,COLOR=COLOR_CURRENT)
oAnnotationLayer->add, oTextAnnotation
search_string = '*ANNOTATION LAYER*TEXT*'+string(num_plots_this_iplot)
idTextAnnotation  = oTool->findIdentifiers(search_string)
;
;  GET THE TEXT DIMENSIONS IN ORDER TO POSITION THE TEXT
;
    idTextAnnotation = oTextAnnotation->GetFullIdentifier()
    textDims         = oTextAnnotation->_GetTextDimensions()
    tmTextAnnotation = oTextAnnotation->GetCTM()
    if(DEBUG eq 1) then begin
      print,'Text Annotation Properties:'
      itpropertyreport, oTool, idTextAnnotation
      print,'Text CTM:'
      print,tmTextAnnotation
      print,'Text Dimensions:'
      print,textDims
    endif
;
; GET THE IDLitVisPlot OBJECT
;
    idPlot = oTool->findIdentifiers('*PLOT*',/VISUALIZATIONS)
    oPlot  = oTool->GetByIdentifier(idPlot)
    tmPlot = oPlot->GetCTM()
    if(DEBUG eq 1) then print,'Plot CTM:'
    if(DEBUG eq 1) then print,tmPlot
;
;  GET THE IDL VIEWPLANE RECT
;
    idVisLayer = oTool->FindIdentifiers('*VIEW_1/VISUALIZATION LAYER')
    oVisLayer  = oTool->GetByIdentifier(idVisLayer)
    oVisLayer->GetProperty,VIEWPLANE_RECT=vrVisLayer
    oVisLayer->GetProperty,MARGIN_2D_X=xMarginVisLayer
    oVisLayer->GetProperty,MARGIN_2D_Y=yMarginVisLayer
    if(DEBUG eq 1) then begin
      print,'Viewplane Rectangle:'
      print,vrVisLayer
      print,'xMarginVisLayer,yMarginVisLayer:'
      print,xMarginVisLayer,yMarginVisLayer
    endif
;
;  SET THE TEXT POSITION
;
    windowTopCoord  = vrVisLayer[1] + vrVisLayer[3]
    plotLeftCoord   = vrVisLayer[0] + xMarginVisLayer*vrVisLayer[2]
    plotBottomCoord = vrVisLayer[1] + yMarginVisLayer*vrVisLayer[3]*plotname_coords_mult
    XCoord          = plotLeftCoord
    YCoord          = plotBottomCoord - plotname_coords_yoffset*num_plots_this_iplot
    oTextAnnotation->translate, XCoord, YCoord, 0
    if(DEBUG eq 1) then begin
      print,plotLeftCoord,plotBottomCoord
      print,plotname_coords_mult,plotname_coords_yoffset
      print,XCoord,YCoord
    endif
;
oTool->CommitActions
;
(*pstate).num_plots(index) = num_plots_this_iplot
(*pstate).xrange           = xrange
(*pstate).yrange           = yrange
(*pstate).xrange_mins(plotwindow_number) = xrange(0)
(*pstate).xrange_maxs(plotwindow_number) = xrange(1)
(*pstate).yrange_mins(plotwindow_number) = yrange(0)
(*pstate).yrange_maxs(plotwindow_number) = yrange(1)
;
end

;-----------------------------------------------------------------
pro SpecprList_listfile, Event
;
; GET INFO FROM THE STRUCTURE ON THE STATE OF THE WIDGETS
;
widget_control,event.top,GET_UVALUE=pstate
DEBUG             = (*pstate).DEBUG
OS_TYPE           = (*pstate).OS_TYPE
DISPLAY_MODE      = (*pstate).DISPLAY_MODE
sfile             = (*pstate).filename
do_singlerec      = (*pstate).do_singlerec
do_records_select = (*pstate).do_records_select
str_default_assocwave = (*pstate).str_default_assocwave
;
; CHECK THAT A SPECPR FILE HAS BEEN READ
;
if(sfile eq (*pstate).unselectedfile) then begin
  err_mesg=['A SPECPR file must be selected.']
  err_mesg=[err_mesg,'Please select a SPECPR file before attempting to list its contents.']
  c=dialog_message(err_mesg)
  RETURN
endif
;
; SET THE LABEL FOR THE LIST WIDGET
;
temp = 'List of SPECPR File '+sfile
Widget_Control,(*pstate).valsLabelID,set_value=temp
;
;  READ THE SPECPR FILE & SET THE STRING ARRAYS FOR THE LIST WIDGET
;
widget_control,/HOURGLASS
wlist_str = create_specpr_listing(FILE_SPECPR=sfile,NUM_RECS=num_recs,RECORD_NUMBERS=recnums)
if(wlist_str(0) eq '-1') then begin
  err_mesg1='Error reading the selected file!'
  err_mesg2='A SPECPR file must be selected.'
  err_mesg3='Please select a SPECPR file before attempting to list its contents.'
  err_mesg=[err_mesg1,err_mesg2,err_mesg3]
  c=dialog_message(err_mesg)
  RETURN
endif
;
; ASSIGN THE NEW STRING ARRAY TO THE LIST WIDGET
;
Widget_Control,(*pstate).valsListID,set_value=[wlist_str]
Widget_Control,(*pstate).valsListID,set_uvalue=[wlist_str]
;
; SET THE UVALUE OF THE WAVE/GOREC LABEL WIDGETS
;
if(DISPLAY_MODE eq 0) then Widget_Control,(*pstate).gorecLabelID,set_uvalue=recnums
if(DISPLAY_MODE eq 1) then Widget_Control,(*pstate).waveLabelID,set_uvalue=recnums
;
; SET THE STATE OF THE LIST WIDGET SO THAT NO RECORDS ARE HIGHLIGHTED
;
temp_str = 'List of SPECPR File '+sfile
Widget_Control,(*pstate).valsLabelID,set_value=temp_str
;
; SET THE WIDGET STATE/APPEARANCE
;
case DISPLAY_MODE of
  0: begin
    if(DEBUG ge 1) then print,'SpecprList_listfile: Here I am 0'
    list_top    = 0
    list_select =-1
    widget_control,(*pstate).valsListID,SET_LIST_TOP=list_top
    widget_control,(*pstate).valsListID,SET_LIST_SELECT=list_select
    Widget_Control,(*pstate).gorecID,set_value='NoneSelected'
    widget_control,(*pstate).waveID,SET_VALUE='-1'
    (*pstate).recnums(*) = 0L
    indices_records = lindgen(num_recs)
    (*pstate).recnums(indices_records) = recnums(*)
    waverec     = 0L
    str_waverec = 'N/A'
    str_assocwave = str_default_assocwave+' '+str_waverec
    Widget_Control,(*pstate).assocwaveTextID,set_value=str_assocwave
    Widget_Control,(*pstate).assocwaveTextID,set_uvalue=waverec
    widget_control,(*pstate).gorecID,TRACKING_EVENTS=1
  end
  1: begin
    if(DEBUG ge 1) then print,'SpecprList_listfile: Here I am 1'
    list_top    =-1
    list_select =-1
    widget_control,(*pstate).valsListID,SET_LIST_TOP=list_top
    widget_control,(*pstate).valsListID,SET_LIST_SELECT=list_select
    widget_control,(*pstate).waveID,SET_VALUE='-1'
    (*pstate).waverec=-1L
  end
  2: begin
    if(DEBUG ge 1) then print,'SpecprList_listfile: Here I am 2'
    list_top    = 1
    list_select = 1
    widget_control,(*pstate).valsListID,SET_LIST_TOP=list_top
    widget_control,(*pstate).valsListID,SET_LIST_SELECT=list_select
    (*pstate).recnums(*) = 0L
    indices_records = lindgen(num_recs)
    (*pstate).recnums(indices_records) = recnums(*)
  end
endcase
;
end


;------------------------------------------------------------------------------------------
FUNCTION Function_SpecprListGui,FILENAME=filename,GROUP_LEADER=group_leader,$
 WAVEONLY=waveonly,FWHMONLY=fwhmonly,RECORDS_SELECT=records_select,$
 TITLE_ADDITION=title_addition,VIEW_SPECPR_SELECT=view_specpr_select,$
 RETURN_SPECPRFILENAME=return_specprfilename
;------------------------------------------------------------------------------
;
; Set RECORDS_SELECT  = 1 to select multiple records
; Set RECORDS_SELECT = -1 to select a single record
;
;
;------------------------------------------------------------------------------
;
; SET DEFAULTS
;
DEBUG   = 0
OS_TYPE = !VERSION.OS_FAMILY
if(DEBUG eq 1) then print,'Operating System Family = ',OS_TYPE
BAD_VALUE = -1.23e+34
PLOTNAME_COORDS_MULT = 1.1
MIN_VALUE = BAD_VALUE+100.   ; THIS IS A PATCH CLEANER CODE IS NEEDED
if keyword_set(FILENAME) then do_filename=1 else do_filename=0
if keyword_set(WAVEONLY) then do_waveonly=1 else do_waveonly=0
if keyword_set(FWHMONLY) then do_fwhmonly=1 else do_fwhmonly=0
if(do_waveonly eq 1 or do_fwhmonly eq 1) then do_singlerec=1 else do_singlerec=0
if keyword_set(RECORDS_SELECT) then begin
  do_records_select=1
  if(RECORDS_SELECT eq -1) then do_singlerec=1
endif else begin
  do_records_select=0
  RECORDS_SELECT = 0
endelse
if keyword_set(TITLE_ADDITION)    then do_title_addition=1    else do_title_addition=0
if keyword_set(VIEW_SPECPR_SELECT)       then do_view_specpr=1       else do_view_specpr=0
if(do_singlerec eq 1 and RECORDS_SELECT eq 1) then begin
  x=DIALOG_MESSAGE('Error: The WAVEONLY and RECORDS_SELECT keywords cannot both be selected.')
  return,-1
endif
case OS_TYPE of
  'Windows': begin
    currDir         = 'c:'
    tempfile        = 'c:/temp.html'
    tempname        = 'temp.html'
    xsize_assocwave = 60
    font_list       = 'courier*8'
  end
  'unix':begin
    currDir         = '/d1/'
    tempfile        = '/tmp/temp.html'
    tempname        = 'temp.html'
    xsize_assocwave = 80
    font_list       = '-adobe-courier-bold-r-normal--12-120-75-75-m-70-hp-roman8'
  end
endcase
REDS        = [  0,255,  0,  0,205,255,  0,150]
GRNS        = [  0,  0,255,  0,155,  0,255,  0]
BLUS        = [  0,  0,  0,255,  0,255,255,  0]
NUM_COLORS  = n_elements(REDS)
MULTIPLIERS = [1.0,0.80,0.60,0.40,0.20]
STR_UNSELECTEDFILE = 'Press Button to Select File'
;
; SET THE DISPLAY MODE
;
if(do_singlerec eq 0 and RECORDS_SELECT eq  0) then DISPLAY_MODE = 0  ;MODE FOR VIEWING SPECPR FILE
if(do_singlerec eq 1 and RECORDS_SELECT eq  0) then DISPLAY_MODE = 1  ;MODE FOR SELECTING A SINGLE RECORD
if(do_singlerec eq 1 and RECORDS_SELECT eq -1) then DISPLAY_MODE = 1  ;MODE FOR SELECTING A SINGLE RECORD
if(do_singlerec eq 0 and RECORDS_SELECT eq  1) then DISPLAY_MODE = 2  ;MODE FOR SELECTING MULTIPLE RECORDS
;
if(DEBUG ge 1) then print,'DEBUG: DISPLAY_MODE = ',DISPLAY_MODE
;
; CHECK FOR THE GROUP LEADER KEYWORD
;
if n_elements(group_leader) eq 0 then modal=0 else modal=1
;
;  READ AND SET THE SPECPR RECORDS IF SPECPR FILE WAS SPECIFIED
;
recnum_array = replicate(0L,100000)
if(do_filename eq 1) then begin
  filename=filename
  valsLabel_text = 'List of SPECPR File '+filename
  wlist_str = create_specpr_listing(FILE_SPECPR=filename,NUM_RECS=num_recs,RECORD_NUMBERS=recnums)
  if(wlist_str(0) eq '-1') then begin
    wlist_str = 'Error reading the listed SPECPR file.'
  endif
  list_text = wlist_str
  uvalue_gorecLabelID = recnums
  if(do_singlerec eq 1) then uvalue_waveLabelID = recnums
  if(do_records_select eq 1) then recnum_array(lindgen(num_recs)) = recnums(*)
endif else begin
  case OS_TYPE of
    'Windows': begin
      valsLabel_text = '            List of SPECPR File            '
      list_text      = '          No data has been read yet.          '
    end
    'unix':begin
      valsLabel_text = '                        List of SPECPR File                        '
      list_text      = '                            No data has been read yet.                            '
    end
  endcase
  filename            = STR_UNSELECTEDFILE
  uvalue_gorecLabelID = 1
  uvalue_waveLabelID  = 1
endelse
;
; SET WIDGET TITLES AND LABELS
;
base_title_default = 'View_Specpr'
case DISPLAY_MODE of
  0:begin
    base_title = base_title_default
    label_text = 'Wavelength Record = '
  end
  1:begin
    label_text = 'Record = '
    base_title = base_title_default+' - Select Data Record'
    if(do_waveonly       eq 1) then begin
      label_text = 'Wavelength Record = '
      base_title = base_title_default+' - Select Wavelength Record'
    endif
    if(do_fwhmonly       eq 1) then begin
      label_text = 'FWHM Record = '
      base_title = base_title_default+' - Select FWHM Record'
    endif
  end
  2:begin
    base_title = base_title_default+' - Select Data Records'
  end
endcase
if(do_title_addition eq 1) then base_title = base_title_default+title_addition
if(do_view_specpr eq 1) then base_title = 'View_SPECPR'
;
; CREATE THE WIDGETS
;
if modal eq 0 then begin
  tlb = Widget_Base(TITLE=base_title,UNAME='tlb',$
   COLUMN=1,MBAR=menubase,XPAD=3,YPAD=3,UVALUE=-1)
endif else begin
  tlb = Widget_Base(TITLE=base_title,UNAME='tlb',$
   COLUMN=1,MBAR=menubase,XPAD=3,YPAD=3,UVALUE=-1,$
   GROUP_LEADER=group_leader)
endelse
;
; SET UP THE MENU ITEMS
;
fileID   = widget_button(menubase,Value='File')
exitID   = widget_button(fileID,Value='Quit',EVENT_PRO='SpecprList_exit')
if(do_view_specpr eq 1) then begin
  helpmenuID = widget_button(menubase,Value='Help')
  helpID     = widget_button(helpmenuID,Value='Help on View_SPECPR',EVENT_PRO='SpecprList_help')
endif
;
; SET THE FILE SELECTOR WIDGETS
;
zone1ID        = widget_base(tlb,ROW=1,XPAD=5,YPAD=4)
selectBaseID   = widget_base(zone1ID,COLUMN=1,XPAD=5,YPAD=2)
selectedFileID = widget_base(selectBaseID,ROW=1,XPAD=5,YPAD=2)
selectLabelID  = Widget_Label(selectedFileID, UNAME='selectLabelID',/ALIGN_LEFT,$
 VALUE='Selected SPECPR File:')
selectTextID   = Widget_Text(selectedFileID,VALUE=filename,$
 UNAME='selectTextID',/ALIGN_LEFT,XSIZE=60)
buttonBaseID         = widget_base(selectBaseID,ROW=1,XPAD=5,YPAD=2)
selectbuttonBaseID   = widget_base(buttonBaseID,ROW=1,XPAD=5,YPAD=5)
selectButtonID       = Widget_Button(selectbuttonBaseID, UNAME='selectButtonID',/ALIGN_LEFT,$
 VALUE='Select SPECPR File',EVENT_PRO='SpecprList_selectfile')
readbuttonBaseID   = widget_base(buttonBaseID,ROW=1,XPAD=25,YPAD=5)
readSpecprID         = Widget_Button(readbuttonBaseID, UNAME='readSpecprID',$
 VALUE='List Selected SPECPR File',EVENT_PRO='SpecprList_listfile')
;
; SET THE LIST BUTTON AND GOTO RECORD BUTTON
;
str_default_assocwave = '... associated wavelength record (in header of selected record) = '
zone2ID   = widget_base(tlb,ROW=1,XPAD=5,YPAD=5)
if(DISPLAY_MODE eq 0 or DISPLAY_MODE eq 2) then begin
  gorecbaseID  = widget_base(zone2ID,ROW=1,XPAD=5,YPAD=5)
  gorecLabelID = widget_label(gorecbaseID,VALUE='Selected Record Number = ',UVALUE=uvalue_gorecLabelID)
  gorecID      = widget_text(gorecbaseID,VALUE='1',/EDITABLE,EVENT_PRO='SpecprList_gorec',/TRACKING_EVENTS,XSIZE=14)
  if(DISPLAY_MODE eq 0) then begin
    assocwaveTextID = widget_text(gorecbaseID,VALUE=str_default_assocwave,XSIZE=xsize_assocwave,UVALUE=0)
;    setwaveButton   = Widget_Button(gorecbaseID, UNAME='setwaveButton',$
;     VALUE='Set as Wavelength Record',EVENT_PRO='SpecprList_setwave')
  endif
endif

valsBaseID     = widget_base(tlb,COLUMN=1,XPAD=5,YPAD=5,/ALIGN_CENTER)
valsLabelID    = Widget_Label(valsBaseID, UNAME='valsLabelID',/ALIGN_CENTER ,VALUE=valsLabel_text)
if(DISPLAY_MODE lt 2) then begin
  valsListID   = Widget_List(valsBaseID, UNAME='valsListID',FONT=font_list,YSIZE=20,$
                VALUE = list_text,UVALUE=list_text,EVENT_PRO='SpecprList_list')
endif else begin
  valsListID   = Widget_List(valsBaseID, UNAME='valsListID',FONT=font_list,YSIZE=20,$
                VALUE = list_text,UVALUE=list_text,/MULTIPLE)
endelse

if(DISPLAY_MODE le 1) then begin
  zone3ID     = widget_base(tlb,ROW=1,XPAD=15,YPAD=10)
  waveBaseID  = widget_base(zone3ID,ROW=1,XPAD=5,YPAD=5)
  waveLabelID = widget_label(waveBaseID,VALUE=label_text,UVALUE=uvalue_waveLabelID)
  waveID      = widget_text(waveBaseID,VALUE='-1',/EDITABLE,$
   EVENT_PRO='SpecprList_wave',/TRACKING_EVENTS)
  if(DISPLAY_MODE eq 0) then begin
    setwaveButton   = Widget_Button(wavebaseID, UNAME='setwaveButton',$
     VALUE='<-- set wavelength record to that associated with selected record listed above',EVENT_PRO='SpecprList_setwave')
  endif
endif


if(do_singlerec ne 1) then begin
  if(do_records_select ne 1) then begin
    zone4ID   = widget_base(tlb,ROW=1,XPAD=15,YPAD=5)
    saveBaseID   = widget_base(zone4ID,COLUMN=1,XPAD=5,YPAD=5)
    saveButton = Widget_Button(saveBaseID, UNAME='saveButton',/ALIGN_CENTER ,$
     VALUE='Save File Listing',EVENT_PRO='SpecprList_save')

    plotBaseID = widget_base(zone4ID,COLUMN=1,XPAD=5,YPAD=5)
    plotButton = Widget_Button(plotBaseID, UNAME='plotButton',/ALIGN_CENTER ,$
     VALUE='Plot Selected Record',EVENT_PRO='SpecprList_plot')

    oplotBaseID = widget_base(zone4ID,COLUMN=1,XPAD=5,YPAD=5)
    oplotButton = Widget_Button(oplotBaseID, UNAME='oplotButton',/ALIGN_CENTER ,$
     VALUE='Overplot Selected Record',EVENT_PRO='SpecprList_oplot')

    showtextBaseID = widget_base(zone4ID,COLUMN=1,XPAD=5,YPAD=5)
    showtextButton = Widget_Button(showtextBaseID, UNAME='showtextButton',/ALIGN_CENTER ,$
     VALUE='Show Text/Manual History/DESCRIPT of Record',EVENT_PRO='SpecprList_text')

  endif else begin
    zone4ID      = widget_base(tlb,ROW=1,XPAD=15,YPAD=5)
    returnBaseID = widget_base(zone4ID,COLUMN=1,XPAD=5,YPAD=5)
    returnButton = Widget_Button(returnBaseID, UNAME='returnButton', UVALUE='returnButton', /ALIGN_CENTER ,$
     VALUE='Return Selected Record Numbers');,EVENT_PRO='SpecprList_exit')
  endelse
endif else begin
  button_text = 'Return Selected Record'
  if(do_fwhmonly eq 1) then button_text = 'Return Selected Wavelength Record'
  if(do_fwhmonly eq 1) then button_text = 'Return Selected FWHM Record'
  zone4ID   = widget_base(tlb,ROW=1,XPAD=15,YPAD=5)
  returnBaseID   = widget_base(zone4ID,COLUMN=1,XPAD=5,YPAD=5)
  returnButton = Widget_Button(returnBaseID, UNAME='returnButton', UVALUE='returnButton', /ALIGN_CENTER ,$
   VALUE=button_text,EVENT_PRO='SpecprList_exit')
endelse
;
Widget_Control, /REALIZE, tlb,  set_uvalue = valsListID
;
; SET UP A STATE STRUCTURE
;
case DISPLAY_MODE of
  0: begin
    state={DEBUG:DEBUG,$
     DISPLAY_MODE:DISPLAY_MODE,$
     OS_TYPE:OS_TYPE,$
     currDir:currDir,$
     currFile:' ',$
     tempfile:tempfile,$
     tempname:tempname,$
     do_singlerec:do_singlerec,$
     do_records_select:do_records_select,$
     BAD_VALUE:BAD_VALUE,$
     MIN_VALUE:MIN_VALUE,$
     filename:filename,$
     unselectedfile:STR_UNSELECTEDFILE,$
     selectTextID:selectTextID,$
     gorecID:gorecID,$
     gorecLabelID:gorecLabelID,$
     valsLabelID:valsLabelID,$
     valsListID:valsListID,$
     waveID:waveID,$
     waveLabelID:waveLabelID,$
     assocwaveTextID:assocwaveTextID,$
     str_default_assocwave:str_default_assocwave,$
     iplotIDs:replicate('empty',100),$
     datarec:0,$
     waverec:-1L,$
     xrange:[0.,1.],$
     yrange:[0.,1.],$
     xrange_mins:replicate(0.0,100),$
     xrange_maxs:replicate(0.0,100),$
     yrange_mins:replicate(0.0,100),$
     yrange_maxs:replicate(0.0,100),$
     num_plot_windows:0,$
     num_plots:replicate(0,100),$
     plotname_coords:[0,0],$
     plotname_coords_mult:PLOTNAME_COORDS_MULT,$
     plotname_coords_yoffset:0.0,$
     NUM_COLORS:NUM_COLORS,$
     MULTIPLIERS:MULTIPLIERS,$
     REDS:REDS,$
     GRNS:GRNS,$
     BLUS:BLUS,$
     recnums:recnum_array,$
     recentiplotid:'empty',$
     tlb:tlb}
  end
  1: begin
    state={DEBUG:DEBUG,$
     DISPLAY_MODE:DISPLAY_MODE,$
     OS_TYPE:OS_TYPE,$
     currDir:currDir,$
     currFile:' ',$
     tempfile:tempfile,$
     tempname:tempname,$
     do_singlerec:do_singlerec,$
     do_records_select:do_records_select,$
     BAD_VALUE:BAD_VALUE,$
     MIN_VALUE:MIN_VALUE,$
     filename:filename,$
     unselectedfile:STR_UNSELECTEDFILE,$
     selectTextID:selectTextID,$
     valsLabelID:valsLabelID,$
     valsListID:valsListID,$
     waveID:waveID,$
     waveLabelID:waveLabelID,$
     str_default_assocwave:str_default_assocwave,$
     iplotID:replicate('empty',100),$
     datarec:0,$
     waverec:-1L,$
     xrange:[0.,1.],$
     yrange:[0.,1.],$
     xrange_mins:replicate(0.0,100),$
     xrange_maxs:replicate(0.0,100),$
     yrange_mins:replicate(0.0,100),$
     yrange_maxs:replicate(0.0,100),$
     num_plots:replicate(0,100),$
     iplotIDs:replicate('empty',100),$
     NUM_COLORS:NUM_COLORS,$
     MULTIPLIERS:MULTIPLIERS,$
     REDS:REDS,$
     GRNS:GRNS,$
     BLUS:BLUS,$
     recnums:recnum_array,$
     tlb:tlb}
  end
  2: begin
    state={DEBUG:DEBUG,$,
     DISPLAY_MODE:DISPLAY_MODE,$
     OS_TYPE:OS_TYPE,$
     currDir:currDir,$
     currFile:' ',$
     tempfile:tempfile,$
     tempname:tempname,$
     do_singlerec:do_singlerec,$
     do_records_select:do_records_select,$
     BAD_VALUE:BAD_VALUE,$
     MIN_VALUE:MIN_VALUE,$
     filename:filename,$
     unselectedfile:STR_UNSELECTEDFILE,$
     selectTextID:selectTextID,$
     gorecID:gorecID,$
     gorecLabelID:gorecLabelID,$
     str_default_assocwave:str_default_assocwave,$
     valsLabelID:valsLabelID,$
     valsListID:valsListID,$
     iplotIDs:replicate('empty',100),$
     datarec:0,$
     waverec:-1L,$
     xrange:[0.,1.],$
     yrange:[0.,1.],$
     num_plots:replicate(0,100),$
     NUM_COLORS:NUM_COLORS,$
     MULTIPLIERS:MULTIPLIERS,$
     REDS:REDS,$
     GRNS:GRNS,$
     BLUS:BLUS,$
     tlb:tlb,$
     recnums:recnum_array,$
     selected_recnums:replicate(0L,100000)}
  end
endcase
;
;SET A POINTER TO THE STATE STRUCTURE AS THE UVALUE OF THE TLB
;
pstate = ptr_new(state,/NO_COPY)
widget_control,tlb,SET_UVALUE=pstate
;
; CALL XMANAGER
xmanager,'SpecprList',tlb,cleanup='SpecprList_cleanup';,/NO_BLOCK
;
return_specprfilename = (*pstate).filename
;
if(do_singlerec eq 1) then begin
  waverec=(*pstate).waverec
  ptr_free,pstate
  return,waverec
endif
if(do_records_select eq 1) then begin
  selected         = (*pstate).selected_recnums
  recnums          = (*pstate).recnums
  index_selected_recnums = where(selected eq 1,count_selected_recnums)
  ptr_free,pstate
  if(count_selected_recnums gt 0) then begin
    return,recnums(index_selected_recnums)
  endif else begin
    return,-1
  endelse
endif
;
return,0
;
end