PRO read_all_specpr_records,specprfile,reclist,titles,NO_PRINT=no_print,NUM_CHANS=num_chans,$
 DATES=dates,REC_TYPES=rec_types,ERROR=error
;
DEBUG = 0
;
if keyword_set(no_print) then do_print=0 else do_print=1
;
irecord     = 1
data        = 1
end_of_file = 0
error       = 0
;
if (DEBUG eq 1) then printval=0 else printval = 1
;
; CHECK THAT THE SPECPR FILE EXISTS
;
test_size = check_specpr_file_size(specprfile,FILE_SIZE=file_size)
if (test_size ne 1) then begin
  str1='Error: The selected file does not have correct file size'
  str2='       to be a SPECPR file (size must be a multiple of 1536 bytes).'
  str3='       Selected file = '+specprfile
  str4='       File size = '+strcompress(string(file_size),/REMOVE_ALL)
  print,str1,str2,str3,str4
  reclist=[-1]
  titles=['Listed file not correct size']
  num_chans=[0]
  dates=[0]
  rec_types=[0]
  error = -1
endif else begin
  openr,lun_specpr,specprfile,ERROR=err,/GET_LUN
  if (err ne 0) then begin
    print,'Error: Could not open SPECPR file'
    print,' Error message = ',!ERROR_STATE.MSG
    reclist=[-1]
    titles=['Listed file does not exist']
    num_chans=[0]
    dates=[0]
    rec_types=[0]
    error = -1
  endif else begin
    close,lun_specpr
    free_lun,lun_specpr
;
; READ THE FIRST RECORD
;
    ival_read = read_specpr(specprfile,irecord,data,title,record_header,NUM_RECS=num_recs,/NO_PLOT,NO_PRINT=printval)
    if(ival_read lt 0) then begin
      error = ival_read
    endif else begin
      reclist = irecord
      titles = title
      rec_types = ival_read
      irecord = irecord + num_recs
      if(ival_read eq 1) then begin      ; TEXT RECORD
        num_chans = record_header.txtch
      endif else begin
        num_chans = record_header.itchan ; DATA RECORD
      endelse
      if(ival_read eq 0) then dates = record_header.jdateb else dates = 0.0
;
;   READ THE REST OF THE RECORDS
;
      while end_of_file ne 1 do begin
        ival_read = read_specpr(specprfile,irecord,data,title,record_header,NUM_RECS=num_recs,/NO_PLOT,NO_PRINT=printval)
        if (ival_read eq -1) then begin
          end_of_file = 1
          if(do_print eq 1) then print,'END OF FILE'
        endif else begin
          if(ival_read eq 1) then begin                 ; TEXT RECORD
            num_chans = [num_chans,record_header.txtch]
            dates     = [dates,0.0]
          endif else begin                              ; DATA RECORD
            num_chans = [num_chans,record_header.itchan]
            dates     = [dates,record_header.jdateb]
          endelse
          if(do_print eq 1) then print,irecord,'  ',title
          reclist  = [reclist,irecord]
          titles   = [titles,title]
          rec_types = [rec_types,ival_read]
          irecord  = irecord + num_recs
        endelse
      endwhile
    endelse
  endelse
endelse
;
end